#include <stdio.h>
#include <math.h>
#include "ssvhwa.h"

#define MCFBAR  0x40000000

#define QADCMCR  (MCFBAR + 0x00190000)  /* 16 bit */
#define QADCTEST (MCFBAR + 0x00190002)  /* 16 bit */
#define PORTQA   (MCFBAR + 0x00190006)  /* 8 bit */
#define PORTQB   (MCFBAR + 0x00190007)  /* 8 bit */
#define DDRQA    (MCFBAR + 0x00190008)  /* 8 bit */
#define DDRQB    (MCFBAR + 0x00190009)  /* 8 bit */
#define QACR0    (MCFBAR + 0x0019000A)  /* 16 bit */
#define QACR1    (MCFBAR + 0x0019000C)  /* 16 bit */
#define QACR2    (MCFBAR + 0x0019000E)  /* 16 bit */
#define QASR0    (MCFBAR + 0x00190010)  /* 16 bit */
#define QASR1    (MCFBAR + 0x00190012)  /* 16 bit */
#define CCW      (MCFBAR + 0x00190200)  /* N bit */
#define RJURR    (MCFBAR + 0x00190280)  /* N bit */
#define LJSRR    (MCFBAR + 0x00190300)  /* N bit */
#define LJURR    (MCFBAR + 0x00190380)  /* N bit */

#define GPTAPORT (MCFBAR + 0x001A001D)  /* 8 bit */
#define GPTADDR  (MCFBAR + 0x001A001E)  /* 8 bit */

#define fichier // sauvegarde dans un fichier => pas d'affichage

#define nbscan 1 // 64

int main (void)
{unsigned char data_b;
 unsigned short data_w,i;
#ifdef fichier
 FILE *f;
 f=fopen("adc.dat","w");
#endif
    // check user identity
    if (geteuid() != 0) {printf("No root access rights !\n");exit(1);}
    if (ssvhwa_open() < 0) {perror("ssvhwa open");exit(-1);}

// set DIL/NetPC PIO Port A = output
 ssvhwa_write8(DDRQA, 0x00);       // Port A[0-3] output : 0x1B
 ssvhwa_write16(QADCMCR, 0x0000);  // enable ADCs
// voir QACR0 pour definir QCK
 ssvhwa_write16(QACR0,0x7f);        // default val = 19

// 52=AN52=PQA0, 53=AN53=PQA1, 62=(VH-VL)/2
for (i=0;i<nbscan*2;i+=2) ssvhwa_write16(CCW+i,0x00C0|52); //queue1 read, 16 ck

while (1) {
 ssvhwa_write16(QASR0,0x0000); 
 ssvhwa_write16(QACR1,0x2100);  // queue 1 single scan mode, software trig 2100
 do {data_w=(ssvhwa_read16(QASR0));
#ifndef fichier
	 printf("QASR0=%x ",data_w);
#endif
 } while ((data_w&0x8000)==0); 
#ifndef fichier
 printf("\n");
 printf("QASR1=%x\n",ssvhwa_read16(QASR1));
 printf("QACR1=%x\n",ssvhwa_read16(QACR1)); // check that scan is complete
#endif
 for (i=0;i<nbscan*2;i+=2) 
   {data_w=ssvhwa_read16(RJURR+i); 
    printf("%x=%d /10=degC",data_w,(int)((float)data_w*3.3/1.024));
#ifdef fichier
	  fprintf(f,"%u\n",data_w);fflush(f);
#endif
  }
 printf("\n");
 sleep(1);
 }
 ssvhwa_close();return(0);
}

