/*
 * SSV HardWareAccess driver for DNP/5280-3V
 * Author  : MHA@SSV <info@dilnetpc.com> <m.hasewinkel@web.de>
 * Date    : 26.08.2003
 * Version : 1.00
 * License : GPL
 */

#ifndef _SSVHWA_H
#define _SSVHWA_H

struct ssvhwa_struct
{
    unsigned long addr;
    unsigned long data;
    unsigned char size;
};

/* default for DNP/5280-3V */
#define SSVHWA_MAJOR 127

#define SSVHWA_IOCTL_BASE 0x7F
#define SSVHWA_INFO     _IOR(SSVHWA_IOCTL_BASE, 0, struct ssvhwa_struct)
#define SSVHWA_READ     _IOR(SSVHWA_IOCTL_BASE, 1, struct ssvhwa_struct)
#define SSVHWA_WRITE    _IOW(SSVHWA_IOCTL_BASE, 2, struct ssvhwa_struct)

#define SSVHWA_VERSION 0x20030826
#define SSVHWA_MAGIC 0x4d484131

#ifndef __KERNEL__
extern int ssvhwa_device;
int ssvhwa_open(void);
void ssvhwa_close(void);
unsigned char ssvhwa_read8(unsigned long);
unsigned short ssvhwa_read16(unsigned long);
unsigned long ssvhwa_read32(unsigned long);
void ssvhwa_write8(unsigned long, unsigned char);
void ssvhwa_write16(unsigned long, unsigned short);
void ssvhwa_write32(unsigned long, unsigned long);
#endif

#endif
