#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <mem_alloc.h>
#include "qadc_cmd.h"

#define DFLT_SIZE 5000

void usage ();
int get_qadc_result (int, struct buffer *);
void show_result (struct buffer *);

void usage ()
{
	return;
}

int get_qadc_result (int desc, struct buffer *buff)
{
	int size = buff->size;
	unsigned int nb_read;
	unsigned char *result = buff->data;

	fprintf (stderr, "enter get_qadc_result ()\n");
	while (size > 2)
	{
		if ((nb_read = read (desc, 
			(unsigned char *) result, size)) == -1)
		{
			perror ("read ()");
			return (-1);
		}
		size -= nb_read;
		fprintf (stderr, "size : %d - nbread : %d\n", size, nb_read);
		fflush (stderr);
		((unsigned char *) result) += nb_read;
	}
	return (0);
}

void show_result (struct buffer *buff)
{
	unsigned int i;
	unsigned short *result = (unsigned short *) buff->data;
	
	for (i = 0; i < (buff->size / sizeof (unsigned short)); i++)
	{
		fprintf (stdout, "%d\n", result[i]);
	}
	return;
}

int main (int argc, char **argv)
{
	int desc, nb_read, i, ask_size, get_size = 0;
	struct buffer *head, *ptr;

	if (argc > 2)
	{
		fprintf (stderr, "error number argument\n");
		usage ();
	}
	ask_size = (argc == 2)? atoi (argv[1]) : DFLT_SIZE;
	head = alloc_mem (ask_size, &get_size);
	fprintf (stderr, "allocate %d bytes for a %d bytes request\n", 
			get_size, ask_size);
	fflush (stderr);
	if (get_size < ask_size)
	{
		fprintf (stderr, "error... to small allocation\n");
		free_mem (head);
		return (-1);
	}
	fflush (stderr);
	if ((desc = open ("/dev/ppp", O_RDONLY)) == -1)
	{
		perror ("open ()");
		return (-1);
	}
	if ((ioctl (desc, CMD_TIMER, 0x14)) < 0)
	{
		perror ("ioctl (CMD_TIMER)");
		return (-1);
	}
	ptr = head;
	while (ptr != NULL)
	{
		if ((get_qadc_result (desc, ptr)) == -1)
			break;

		ptr = ptr->next;
	}
	close (desc);
	fprintf (stderr, "wait... recording data\n");
	fflush (stderr);
	ptr = head;
	while (ptr != NULL)
	{
		show_result (ptr);
		ptr = ptr->next;
	}
	free_mem (head);
	return (0);
}	
